/***
 * 发送：
 *  _act : string
 *  _tflag: int
 *  else:  string
 *
 * 接收：
 *  _act : string
 *  _tflag:int
 *  code:  int     - 错误码
 *  info:  string  - 错误信息
 *  retData: 返回的数据JSON
 *      {_more : 1 - int 表示还有多的数据，js不会清理掉callback}
 */

var CARDREADER = new function(){
    var cbs = {};
    var _CONNECT = function(data, callback) {
        var _wsImpl = window.WebSocket || window.MozWebSocket;
        if(_wsImpl==null){
            callback({code:700, info:"你的浏览器不支持WebSocket"});
            return;
        }
        if(window.wst != null){
            return;  //TODO 消息入栈
        }
        console.log("connecting...")
        window.wst = new _wsImpl('ws://127.0.0.1:17797/');
        wst.onmessage = function (evt) {
            var rdata = evt.data;
            console.log("收到数据，长度："+rdata.length);
            rdata = eval("rdata="+rdata);
            var tflag = rdata._tflag;
            delete rdata._tflag;
            cbs[tflag](rdata);
            if(rdata.retData==null || rdata.retData._more!= 1)//后续没有数据了
                delete cbs[tflag];
        };
        wst.onopen = function(){
            console.log("connected!!")
            window.ws = wst;
            delete window.wst;
            if(data==null) return;
            _SEND(data, callback);
            data = null;
            callback = null;
        }
        wst.onclose = function () {
            console.log("closed!!");
            if(callback!=null) callback({code:701, info:"PC端服务中间件未运行"});
            for(var i in cbs){
                cbs[i]({code:702, info:"PC端服务中间件已关闭"});
                delete cbs[i];
            }
            delete window.ws;
            delete window.wst;
        }
    };

    _SEND = function(data, callback){
        if(window.ws==null){
            _CONNECT(data, callback);
            return;
        }
        var tflag = new Date().getTime()%100000000;
        data._tflag = tflag;
        cbs[tflag] = callback;
        try{
            ws.send(JSON.stringify(data));
        }catch (e) {
            callback({code:700, info:"PC端服务中间件未运行"});
        }
    };

    this.send = function(data, callback){
        //data = JSON.stringify(data);
        showMsg("<span style='color:darkgreen;'>发送数据：" + JSON.stringify(data)+"</span>");
        _SEND(data, callback);
    }
};
